{$DEFINE DO0}
{$DEFINE DMI}
{$DEFINE DEBUG}
{$IFDEF DEBUG}
{$B-,I+,N+,O-,Q+,R+,S+}
{$ELSE}
{$B-,I-,N+,O+,Q-,R-,S-}
{$ENDIF}
{$APPTYPE CONSOLE}
Program OlympSol;
uses SysUtils;

const TaskName = 'worker';
 MaxN = 100005;

var i, k, m, n: Integer;
 h: array [1..MaxN] of Integer;

procedure minheapup (i: Integer);
var x, j: Integer;
begin
 x := h[i];
 repeat
  j := i shr 1; // div 2
  if (j = 0) OR (h[j] <= x) then break; // no way up or heap rule satisfied
  h[i] := h[j];
  i := j;
 until False;
 h[i] := x;
end;

procedure minheapdown (i: Integer);
var x, j: Integer;
begin
 x := h[i];
 repeat
  j := i shl 1; // * 2
  if j > m then break; // no way down
  if (j < m) AND (h[j + 1] < h[j]) then inc (j); // find the minimum
  if x <= h[j] then break; // heap rule satisfied
  h[i] := h[j];
  i := j;
 until False;
end;

BEGIN
 reset (input, TaskName + '.in');
 rewrite (output, TaskName + '.out');
{$IFDEF DMI} repeat {$ENDIF}
 fillchar (h, sizeof (h), 0);
 read (n);
 m := 0;
 for i := 1 to n do begin
  read (k);
  if k > 0 then begin
   inc (m);
   h[m] := k;
   minheapup (m);
  end else begin
   assert (m > 0);
   writeln (h[1]);
   h[1] := h[m];
   dec (m);
   minheapdown (1);
  end;
 end;
{$IFDEF DMI} if NOT seekeof then writeln; until seekeof; {$ENDIF}
END.
