{$B-,I+,N+,O-,Q+,R+,S+}
{$APPTYPE CONSOLE}
Program Check;
uses SysUtils;

const TaskName = 'scales';
 MaxN = 14; MaxK = 1 shl MaxN;
 OK = 0; WA = 1;

var i, j, k, l, m, n: Integer;
 b: array [0..MaxK] of Boolean;
 fin, fout: Text;

procedure quit (code: Integer; line: String);
begin
 writeln (line);
 halt (code);
end;

BEGIN
 reset (fin, TaskName + '.in');
 read (fin, n);
 k := 0;
 for i := 1 to n do begin
  read (fin, j);
  k := (k shl 1) + j;
 end;
 close (fin);
 reset (fout, TaskName + '.out');
 l := (1 shl n) - 1;
 read (fout, m);
 if m <> l then quit (WA, format ('Wrong answer: %d.', [m]));
 fillchar (b, sizeof (b), 0);
 b[k] := True;
 for i := 1 to m do begin
  read (fout, j);
  if (j < 1) OR (j > n) then
   quit (WA, format ('Index out of range: %d at line %d.', [j, i + 1]));
  k := k xor (1 shl (j - 1));
  b[k] := True;
 end;
 close (fout);
 for i := 0 to m - 1 do
  if NOT b[i] then
   quit (WA, format ('Configuration not covered: %d.', [i]));
 quit (OK, 'OK.');
END.
